program Wilde13;
{ 4 Reihen zu 13 Karten austeilen, abraeumen nach Schlagprinzip, 4 Stacks, }
{ 4 Ablagen, Koenig muss uebrigbleiben }
{ Vers. 0.990: 27.09.96: 1. spielbare Version }
{ Vers. 1.000: 28.09.96: Messages, Endcheck, Zugruecknahme, Help, Cursor }

{$M 8192,0,655360}
uses crt,dos,graph,drivers,intuit;

const titel='        Wilde 13                  -   uja Vers.1.000             TP6.01';
      dx=48; dy=80; ysize=80; ox=-44; oy=48; sx=456; sy=16;
      xmax=13; ymax=4;
      imafil='cards.ima';
      pal:array[0..15,0..2] of word=(
         ( 0, 0, 0),( 0, 0,42),( 0,27, 0),(49,55,55),
         (42, 5, 0),( 0,24,23),(30, 0, 0),(44,39,35),
         (21,21,21),(21,21,63),(21,63,21),(21,63,63),
         (63,27,11),(59,52,51),(63,46, 0),(61,58,56));

var ok,ende,fertig                      :boolean;
    cardmark,cardmask                   :array[1..4] of Image;
    itext1,itext2                       :array[1..6] of Intuitext;
    ibord1,ibord2,cb1,cb2,cb3,cb4       :Border;
    xy,xy2,cxy                          :Koords;
    bgr1,bgr2,mask,leer,reserve         :Image;
    igad                                :array[1..10] of Gadget;
    g,mx,my,x,y,index,i,selx,sely,cx,cy :integer;
    ch                                  :char;
    karte                               :array[1..52] of Image;
    talon,cards                         :array[0..52] of word;
    ablage,stacko,oabl,ostack           :array[1..4,0..52] of word;
    feld,ofeld                          :array[1..13,1..4] of word;

{ === Karten - allgemeiner Teil ========================================== }

procedure getimages;
var i:integer;
    anz:word;
    fh:file;
begin
   assign(fh,imafil);
   reset(fh,1);
   for i:=1 to 52 do begin
      BlockRead(fh,karte[i],sizeof(image),anz);
      anz:=Imagesize(1,1,karte[i].width,karte[i].height);
      GetMem(karte[i].p_data,anz);
      BlockRead(fh,karte[i].p_data^,anz,anz);
   end;
   for i:=1 to 4 do begin
      BlockRead(fh,cardmask[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmask[i].width,cardmask[i].height);
      GetMem(cardmask[i].p_data,anz);
      BlockRead(fh,cardmask[i].p_data^,anz,anz);
      BlockRead(fh,cardmark[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmark[i].width,cardmark[i].height);
      GetMem(cardmark[i].p_data,anz);
      BlockRead(fh,cardmark[i].p_data^,anz,anz);
   end;
   BlockRead(fh,leer,sizeof(image),anz);
   anz:=Imagesize(1,1,leer.width,leer.height);
   GetMem(leer.p_data,anz);
   BlockRead(fh,leer.p_data^,anz,anz);
   BlockRead(fh,bgr1,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr1.width,bgr1.height);
   GetMem(bgr1.p_data,anz);
   BlockRead(fh,bgr1.p_data^,anz,anz);
   BlockRead(fh,bgr2,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr2.width,bgr2.height);
   GetMem(bgr2.p_data,anz);
   BlockRead(fh,bgr2.p_data^,anz,anz);
   close(fh);
   leer.width:=dx; leer.height:=dy;
   putimage(1,1,leer.p_data^,normalput);
   getimage(1,1,dx,dy,leer.p_data^);
   with reserve do begin
      x:=0; y:=0; width:=dx; height:=dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
   end;
end;

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,i);
end;
end;

{ ------------------------------------------------------------------------ }

procedure anhalten(var ende:boolean);
var ch:char;  g,mx,my:integer;
begin
ch:=chr(0);
g:=0;
showmouse;
   repeat
      maustastelos(g,mx,my);
      if keypressed then ch:=readkey;
      ende:= (ch in [#27,'Q','q']) or (g=4);
   until (ch<>chr(0)) or (g<>0);
hidemouse;
end;

procedure intuikram;
var i:integer;
begin
   for i:=1 to 6 do with itext1[i] do begin
      x:=8; y:=5; fpen:=15; bpen:=7; p_nexttext:=addr(itext2[i]);
      case i of
      1: itext:=' Back';
      2: itext:=' Alt';
      3: itext:=' Neu';
      4: itext:=' Quit';
      5: begin itext:='Mll'; x:=14; y:=32; end;
      6: itext:='Hilfe';
      end;
   end;
   for i:=1 to 6 do with itext2[i] do begin
      x:=pred(itext1[i].x); y:=itext1[i].y; fpen:=0; bpen:=itext1[i].bpen;
      itext:=itext1[i].itext; p_nexttext:=nil;
   end;

   xy[0]:=0;  xy[1]:=0; xy[2]:=56;  xy[3]:=0; xy[4]:=56;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   xy2[0]:=0;  xy2[1]:=0; xy2[2]:=112; xy2[3]:=0; xy2[4]:=112;
   xy2[5]:=15; xy2[6]:=0; xy2[7]:=15;  xy2[8]:=0; xy2[9]:=0;
   with ibord1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

   cxy[0]:=0;    cxy[1]:=0;      cxy[2]:=dx-3;   cxy[3]:=0;      cxy[4]:=cxy[2];
   cxy[5]:=dy-3; cxy[6]:=cxy[0]; cxy[7]:=cxy[5]; cxy[8]:=cxy[0]; cxy[9]:=cxy[1];
   with cb1 do begin
      x:=0; y:=0; fpen:=14; bpen:=7; ecken:=5; p_ecken:=addr(cxy);
      p_nextborder:=addr(cb2);
   end;
   with cb2 do begin
      x:=2; y:=2; fpen:=4; bpen:=7; ecken:=5; p_ecken:=addr(cxy);
      p_nextborder:=nil;
   end;

{ back, alt, neu, quit: }
   for i:=1 to 4 do with igad[i] do begin
      id:=i;
      x:=sx+(i-2)*56;
      y:=456;
      width:=56;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      if i=1 then p_lointuitext:=nil;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   for i:=5 to 8 do with igad[i] do begin
      id:=i;
      x:=ox+(i-4)*56;
      y:=32;
      width:=56;
      height:=80;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=addr(bgr2);
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[5]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=9;
   with igad[i] do begin
      id:=i;
      x:=ox+dx;
      y:=oy+dy;
      width:=dx*xmax+8;
      height:=dy*ymax;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=10;
   with igad[i] do begin
      id:=i;
      x:=ox+dx+8;
      y:=456;
      width:=56;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[6]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure darken;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,i);
end;

procedure buildscreen;
var i:integer;
    b1,b2:Border;
    xy   :Koords;
    temp:string;
begin
{ Background: }
   xy[0]:=0;  xy[1]:=0; xy[2]:=631; xy[3]:=0; xy[4]:=631;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   with b1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(b2);
   end;
   with b2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;
   rectfill(0,0,639,479,5);
   rectfill(2,2,635,17,7);
   DrawBorder(2,2,addr(b1));
   setcolor(15); outtextxy(33,7,titel);
   setcolor(0);  outtextxy(32,7,titel);
   putimage(224,5,cardmask[1].p_data^,andput);
   putimage(225,5,cardmark[1].p_data^,orput);
   for i:=2 to 4 do begin
      putimage(i*16-20,5,cardmask[i].p_data^,andput);
      putimage(i*16-19,5,cardmark[i].p_data^,orput);
   end;
   RefreshGadgets(addr(igad[1]));
end;

procedure mischen;
var i,j,k:integer;
begin
   for i:=1 to 4 do ablage[i,0]:=0;
   for i:=1 to 4 do stacko[i,0]:=0;
   for j:=1 to 4 do for i:=1 to 13 do feld[i,j]:=0;
   for i:=1 to 52 do cards[i]:=i;
   randomize;
   for i:=1 to cards[0] do begin
      j:=succ(random(1000) mod cards[0]);
      k:=cards[i];
      cards[i]:=cards[j];
      cards[j]:=k;
   end;
   talon:=cards;
end;


procedure zeichnereihe(nrow,ncol:word);
var i:integer;
begin
rectfill(0,nrow*dy+oy,639,succ(nrow)*dy+oy,5);
for i:=1 to ncol do if feld[i,nrow]>0 then
putimage(i*dx+ox,nrow*dy+oy,karte[feld[i,nrow]].p_data^,normalput)
end;


procedure auslegen(ncol,nrow:word);
var i,j,k:integer;
    temp:string;
begin
   for i:=1 to nrow do for j:=1 to ncol do if talon[0]>0 then begin
      feld[j,i]:=talon[talon[0]];
      dec(talon[0]);
   end;
   for i:=1 to nrow do zeichnereihe(i,ncol);
end;

procedure markiere(ncol,nrow:integer);
var x,y,z:integer;
begin
   x:=ncol*dx+ox;
   y:=nrow*dy+oy;
   putimage(x,y,leer.p_data^,andput);
end;

procedure demarkiere(ncol,nrow:integer);
var x,y,z:integer;
begin
   x:=ncol*dx+ox;
   y:=nrow*dy+oy;
   putimage(x,y,leer.p_data^,orput);
end;

procedure zeichnestacko(nr:word);
begin
   if stacko[nr,0]>0 then putimage(nr*56+ox,32,karte[stacko[nr,stacko[nr,0]]].p_data^,normalput)
   else begin
      putimage(nr*56+ox,32,bgr2.p_data^,normalput);
      DrawIntuiText(nr*56+ox,32,addr(itext1[5]));
      setcolor(15); outtextxy(nr*56+ox+25,80,chr(48+nr));
      setcolor( 0); outtextxy(nr*56+ox+24,80,chr(48+nr));
   end;
end;

procedure zeichneablage(nr:word);
var x,y:integer;
begin
   if ablage[nr,0]>0 then putimage((nr+7)*56+ox,32,karte[ablage[nr,ablage[nr,0]]].p_data^,normalput)
   else begin
      putimage((nr+7)*56+ox,32,bgr2.p_data^,normalput);
      putimage(nr*56+370,64,cardmask[nr].p_data^,andput);
      putimage(nr*56+371,64,cardmark[nr].p_data^,orput);
   end;
end;

procedure messi(temp:string; saund:boolean);
begin
   rectfill(116,460,320,475,5);
   setcolor( 0); outtextxy(134,462,temp);
   setcolor(15); outtextxy(132,462,temp);
   if saund then sound(50);
   delay(100);
   nosound;
end;

procedure upbacken;
begin
ofeld:=feld;
oabl:=ablage;
ostack:=stacko;
igad[1].onoff:=true;
DrawGadget(addr(igad[1]));
end;

procedure restoren;
var i:integer;
begin
feld:=ofeld;
ablage:=oabl;
stacko:=ostack;
igad[1].onoff:=false;
DrawGadget(addr(igad[1]));
for i:=1 to 4 do begin
   zeichnereihe(i,13);
   zeichneablage(i);
   zeichnestacko(i);
end;
end;


procedure checkstackos;
var i,j,k,farbe,wert,f2,w2:integer;
begin
   for i:=1 to 4 do if stacko[i,0]>0 then begin
      farbe:=pred(stacko[i,stacko[i,0]]) div 13;   { 0 -  3 }
      inc(farbe);
      wert:=pred(stacko[i,stacko[i,0]]) mod 13;    { 0 - 12 }
      if ablage[farbe,0]>0 then begin
         w2:=pred(ablage[farbe,ablage[farbe,0]]) mod 13;    { 0 - 12 }
         if w2=pred(wert) then begin
            inc(ablage[farbe,0]);
            ablage[farbe,ablage[farbe,0]]:=stacko[i,stacko[i,0]];
            dec(stacko[i,0]);
            zeichneablage(farbe);
            zeichnestacko(i);
         end;
      end;
   end;
end;

procedure zug(selx,sely,x,y:integer);
var ok:boolean;
    wert,farbe,w2,g:integer;
begin
   upbacken;
   farbe:=pred(feld[x,y]) div 13;   { 0 -  3 }
   inc(farbe);
   wert:=pred(feld[x,y]) mod 13;    { 0 - 12 }
   if ablage[farbe,0]=0 then ok:=wert=0 else begin
      w2:=pred(ablage[farbe,ablage[farbe,0]]) mod 13;
      ok:=wert=succ(w2);
   end;
   if ok then begin
      inc(ablage[farbe,0]);
      ablage[farbe,ablage[farbe,0]]:=feld[x,y];
      zeichneablage(farbe);
      feld[x,y]:=feld[selx,sely];
      feld[selx,sely]:=0;
   end else begin
      messi('Bitte Stack whlen!',true);
      putimage(x*dx+ox,y*dy+oy,leer.p_data^,orput);
      g:=0;
      repeat
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         if keypressed then begin
            ch:=readkey;
            case ch of
            #27,'Q','q'       : g:=4;
            '1'..'4'          : g:=ord(ch)-44;
            else g:=15;
            end;
         end;
         case g of
         4   : ende:=true;
         5..8: begin
                  farbe:=g-4;
                  inc(stacko[farbe,0]);
                  stacko[farbe,stacko[farbe,0]]:=feld[x,y];
                  feld[x,y]:=feld[selx,sely];
                  feld[selx,sely]:=0;
                  zeichnestacko(farbe);
               end;
         end;
      until g>0;
      messi('',false);
   end;
end;


procedure initgame(mix:boolean);
var i:integer;
begin
   talon[0]:=52;
   cards[0]:=52;
   for i:=1 to 4 do begin
      stacko[i,0]:=0;
      ablage[i,0]:=0;
      zeichneablage(i);
      zeichnestacko(i);
   end;
   if mix then mischen;
   auslegen(13,4);
   getimage(cx*dx+ox,cy*dy+oy,pred(succ(cx)*dx+ox),pred(succ(cy)*dy+oy),
            reserve.p_data^);
   fertig:=false;
   ende:=false;
   selx:=0;
   ofeld:=feld;
   ostack:=stacko;
   oabl:=ablage;
end;


procedure endcheck(var fertig:boolean);
var i,j,k:integer;
begin
k:=0;
for i:=1 to xmax do for j:=1 to ymax do if feld[i,j]>0 then inc(k);
if k<2 then begin
   k:=0;
   for i:=1 to 4 do k:=stacko[i,0]+k;
   fertig:=k=0;
end;
if fertig then delay(2000);
end;

{ ======================================================================== }

procedure fanfare;
var i,x,y,a,a1,a2:integer;
    r1,r2  :real;
    temp   :string;
begin
randomize;
i:=52*50-13;
a:=0;
while (i>0) and not keypressed do begin
   dec(i);
   r1:=i*0.15;
   r2:=i*0.10;
   x:=trunc(r1*sin(r2))+320;
   y:=trunc(r2*cos(r1))+240;
   a:=a+1; if a>52 then a:=a-52;
   putimage(x,y,karte[a].p_data^,normalput);
   delay(5);
end;
x:=16; y:=460;
rectfill(x-8,y-8,x+480,y+16,0);
rectfill(x-7,y-7,x+479,y+15,15);
rectfill(x-6,y-6,x+478,y+14,7);
temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
setcolor(15); outtextxy(x,y,temp);
setcolor(0);  outtextxy(pred(x),y,temp);
ch:=readkey; if ch=#0 then ch:=readkey;
ende:=ch=#27;
if not ende then begin
   buildscreen;
   RefreshGadgets(addr(igad[1]));
   initgame(true);
end;
end;


procedure helpscreen;
const ofy=12;
var c,i,x1,x2,y1,y2:integer;
    temp          :string;
begin
x1:=32; y1:=48; x2:=x1+560; y2:=y1+320;
rectfill(x1,y1,x2,y2,0);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,15);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,7);
putimage(574,350,cardmask[1].p_data^,andput);
putimage(575,350,cardmark[1].p_data^,orput);

x1:=x1+8;
for i:=1 to 22 do begin
   case i of
   1                  : y1:=y1+8;
   2                  : y1:=y1+16;
   3..10,13..16,19    : y1:=y1+ofy;
   11,12,17,21        : y1:=y1+16;
   18,20              : y1:=y1+10;
   22                 : y1:=y1+24;
   end;
   case i of
   1,11..20,22    : c:=0;
   2..10          : c:=1;
   7..8           : c:=6;
   21             : c:=8;
   end;

   case i of
   1: temp:='W i l d e      D r e i z e h n :';
   2: temp:='Bei der Wilden 13 werden Karten in aufsteigenden Reihen abgerumt';
   3: temp:='beginnend mit den ssen, den 2en, den 3en u.s.w. der gleichen Far-';
   4: temp:='ben. Ausgeteilt werden 52 Karten in 4 Reihen zu 13. Die Karten wer-';
   5: temp:='den auf dem Stack abgelegt, indem man sie mit einer Nachbarkarte   ';
   6: temp:='dorthin "vertreibt". Die Nachbarkarte nimmt dann den Platz der "ver-';
   7: temp:='triebenen" Karte ein. Kann die vertriebene Karte nicht auf einem der';
   8: temp:='Stacks abgelegt werden, landet sie auf einem der 4 Mllhaufen. Bei';
   9: temp:='passender Gelegenheit wandert sie von da auf den Stack.';
  10: temp:='Zuletzt sollte ein Knig im Spielfeld uebrigbleiben.';
   11: temp:='Steuerung                mit Keyboard:                   mit Maus:';
   12: temp:='vertreibende Karte     : mit Cursor whlen, [enter]      anklicken';
   13: temp:='die zu vertreibende    : mit Cursor whlen, [enter]      anklicken';
   14: temp:='Mu diese auf den Mll : Nr. des Haufens eingeben [1-4]  Mllhaufen';
   15: temp:='                                                         anklicken';
   16: temp:='Bei gltiger Wahl wird der Zug durchgefhrt.';
   17: temp:='Zugrcknahme           :  [B]                            [ Back ]';
   18: temp:='Spiel von vorne        :  [A]                            [  Alt ]';
   19: temp:='neues Spiel            :  [N]                            [  Neu ]';
   20: temp:='Ende                   :  [Q],[esc]                      [ Quit ]';
   21: temp:='Laut einer weisen alten Dame soll das Spiel immer aufgehen ... ;-)';
   22: temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
   end;
   setcolor(15); outtextxy(x1,y1,temp);
   setcolor(c);  outtextxy(pred(x1),y1,temp);
end;
anhalten(ende);
if not ende then begin
   buildscreen;
   for i:=1 to 4 do begin
      zeichnestacko(i);
      zeichneablage(i);
   end;
   auslegen(13,4);
end;
end;

{ ======================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      darken;
      getimages;
      intuikram;
      buildscreen;
      lighten;
      cx:=1; cy:=1;
      initgame(true);
      while not ende do begin
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         checkstackos;
         endcheck(fertig);
         if keypressed then begin
            ch:=readkey;
            case ch of
            #0                : begin
                                   ch:=readkey;
                                   putimage(cx*dx+ox,cy*dy+oy,reserve.p_data^,normalput);
                                   case ch of
                                   #59: g:=10;
                                   #72: if cy>1 then dec(cy);
                                   #75: if cx>1 then dec(cx);
                                   #77: if cx<xmax then inc(cx);
                                   #80: if cy<ymax then inc(cy);
                                   end;
                                   getimage(cx*dx+ox,cy*dy+oy,
                                   pred(succ(cx)*dx+ox),pred(succ(cy)*dy+oy),
                                   reserve.p_data^);
                                   if selx>0 then markiere(selx,sely);
                                end;
            #13,#32           : if feld[cx,cy]>0 then begin
                                if selx=0 then begin
                                   selx:=cx; sely:=cy;
                                   if feld[selx,sely]>0 then markiere(selx,sely) else selx:=0;
                                end else begin
                                   x:=cx;
                                   y:=cy;
                                   ok:=(x=selx) and (abs(y-sely)=1);
                                   ok:=ok or ((abs(x-selx)=1) and (y=sely));
                                   ok:=ok and (feld[x,y]>0);
                                   if ok then begin
                                      zug(selx,sely,x,y);
                                      selx:=0;
                                      zeichnereihe(sely,13);
                                      if y<>sely then zeichnereihe(y,13);
                                   end else begin
                                      selx:=0;
                                      zeichnereihe(sely,13);
                                   end;
                                   getimage(cx*dx+ox,cy*dy+oy,
                                   pred(succ(cx)*dx+ox),pred(succ(cy)*dy+oy),
                                   reserve.p_data^);
                                end;
                                end;
            #27,'Q','q'       : g:=4;
            'A','a'           : g:=2;
            'B','b'           : g:=1;
            'H','h'           : g:=10;
            'N','n'           : g:=3;
            end;
            Drawborder(cx*dx+ox,cy*dy+oy,addr(cb1));
         end;
         case g of
         1: begin
               restoren;
               getimage(cx*dx+ox,cy*dy+oy,
               pred(succ(cx)*dx+ox),pred(succ(cy)*dy+oy),reserve.p_data^);
             end;
         2: initgame(false);
         3: initgame(true);
         4: ende:=true;
         9: begin { Karte waehlen }
                if selx=0 then begin
                   selx:=(mx-ox) div dx;
                   if selx>13 then selx:=13;
                   sely:=(my-oy) div dy;
                   if sely>4 then sely:=4;
                   if feld[selx,sely]>0 then markiere(selx,sely) else selx:=0;
                end else begin
                   x:=(mx-ox) div dx;
                   if x>13 then x:=13;
                   y:=(my-oy) div dy;
                   if y>4 then y:=4;
                   ok:=(x=selx) and (abs(y-sely)=1);
                   ok:=ok or ((abs(x-selx)=1) and (y=sely));
                   ok:=ok and (feld[x,y]>0);
                   if ok then begin
                      zug(selx,sely,x,y);
                      selx:=0;
                      zeichnereihe(sely,13);
                      if y<>sely then zeichnereihe(y,13);
                   end else begin
                      selx:=0;
                      zeichnereihe(sely,13);
                   end;
                end;
             end;
         10: helpscreen;
         end;
         if fertig then fanfare;
      end;
   end;
   textmode(3);
end.
